/**
 * 
 *
 * Generated by <a href="http://enunciate.webcohesion.com">Enunciate</a>.
 */
 
/**
 * UMD load definition that supports AMD, CommonJS and browser globals.
 * https://github.com/umdjs/umd/blob/992cc0d071b7ebcd7feaad2a5349bdbeab09a0fe/commonjsStrict.js
 */
(function (root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['exports'], factory);
  } else if (typeof exports === 'object') {
    // CommonJS
    factory(exports);
  } else {
    // Browser globals
    factory(root.javascriptClient = {});
  }
}(this, function (exports) {
 
 'use strict';
 

/**
 * (no documentation provided)
 */
ensureNamespace('Nl.Uva.Sne.Drip.Commons.V1.Types');
exports.Nl.Uva.Sne.Drip.Commons.V1.Types.User = class {

    /**
     * Constructs a User from a JSON object
     *
     * @param Object o JSON object.
     */
    constructor(o) {
        var self = this;
        if (typeof o['password'] !== 'undefined') {
            this.password = o['password'];
        }
        if (typeof o['id'] !== 'undefined') {
            this.id = o['id'];
        }
        if (typeof o['username'] !== 'undefined') {
            this.username = o['username'];
        }
        if (typeof o['accountNonExpired'] !== 'undefined') {
            this.accountNonExpired = o['accountNonExpired'];
        }
        if (typeof o['accountNonLocked'] !== 'undefined') {
            this.accountNonLocked = o['accountNonLocked'];
        }
        if (typeof o['credentialsNonExpired'] !== 'undefined') {
            this.credentialsNonExpired = o['credentialsNonExpired'];
        }
        if (typeof o['enabled'] !== 'undefined') {
            this.enabled = o['enabled'];
        }
        this.roles = [];
        if (o['roles']) {
            o['roles'].forEach(function(x, i){
                self.roles[i] = x;
            });
        }
    }

    /**
     * (no documentation provided)
     *
     * @return string
     */
    getPassword() {
        return this.password;
    }

    /**
     * (no documentation provided)
     *
     * @param string password
     */
    setPassword(password) {
        this.password = password;
    }
    /**
     * the id
     *
     * @return string
     */
    getId() {
        return this.id;
    }

    /**
     * the id
     *
     * @param string id
     */
    setId(id) {
        this.id = id;
    }
    /**
     * 
     *
     * @return string
     */
    getUsername() {
        return this.username;
    }

    /**
     * 
     *
     * @param string username
     */
    setUsername(username) {
        this.username = username;
    }
    /**
     * 
     *
     * @return boolean
     */
    getAccountNonExpired() {
        return this.accountNonExpired;
    }

    /**
     * 
     *
     * @param boolean accountNonExpired
     */
    setAccountNonExpired(accountNonExpired) {
        this.accountNonExpired = accountNonExpired;
    }
    /**
     * 
     *
     * @return boolean
     */
    getAccountNonLocked() {
        return this.accountNonLocked;
    }

    /**
     * 
     *
     * @param boolean accountNonLocked
     */
    setAccountNonLocked(accountNonLocked) {
        this.accountNonLocked = accountNonLocked;
    }
    /**
     * 
     *
     * @return boolean
     */
    getCredentialsNonExpired() {
        return this.credentialsNonExpired;
    }

    /**
     * 
     *
     * @param boolean credentialsNonExpired
     */
    setCredentialsNonExpired(credentialsNonExpired) {
        this.credentialsNonExpired = credentialsNonExpired;
    }
    /**
     * 
     *
     * @return boolean
     */
    getEnabled() {
        return this.enabled;
    }

    /**
     * 
     *
     * @param boolean enabled
     */
    setEnabled(enabled) {
        this.enabled = enabled;
    }
    /**
     * the roles
     *
     * @return string[]
     */
    getRoles() {
        return this.roles;
    }

    /**
     * the roles
     *
     * @param string[] roles
     */
    setRoles(roles) {
        this.roles = roles;
    }

    /**
     * Returns a JSON object for this User
     *
     * @return object
     */
    toJSON() {
        var json = {};
        var self = this;
        if (typeof this.password !== 'undefined') {
            json['password'] = this.password;
        }
        if (typeof this.id !== 'undefined') {
            json['id'] = this.id;
        }
        if (typeof this.username !== 'undefined') {
            json['username'] = this.username;
        }
        if (typeof this.accountNonExpired !== 'undefined') {
            json['accountNonExpired'] = this.accountNonExpired;
        }
        if (typeof this.accountNonLocked !== 'undefined') {
            json['accountNonLocked'] = this.accountNonLocked;
        }
        if (typeof this.credentialsNonExpired !== 'undefined') {
            json['credentialsNonExpired'] = this.credentialsNonExpired;
        }
        if (typeof this.enabled !== 'undefined') {
            json['enabled'] = this.enabled;
        }
        if (this.roles) {
            json['roles'] = [];
            this.roles.forEach(function(x, i){
                json['roles'][i] = x;
            });
        }
        return json;
    }

}

/**
 * (no documentation provided)
 */
ensureNamespace('Nl.Uva.Sne.Drip.Commons.V1.Types');
exports.Nl.Uva.Sne.Drip.Commons.V1.Types.OwnedObject = class {

    /**
     * Constructs a OwnedObject from a JSON object
     *
     * @param Object o JSON object.
     */
    constructor(o) {
        var self = this;
        if (typeof o['owner'] !== 'undefined') {
            this.owner = o['owner'];
        }
    }

    /**
     * the owner
     *
     * @return string
     */
    getOwner() {
        return this.owner;
    }

    /**
     * the owner
     *
     * @param string owner
     */
    setOwner(owner) {
        this.owner = owner;
    }

    /**
     * Returns a JSON object for this OwnedObject
     *
     * @return object
     */
    toJSON() {
        var json = {};
        var self = this;
        if (typeof this.owner !== 'undefined') {
            json['owner'] = this.owner;
        }
        return json;
    }

}

/**
 * (no documentation provided)
 */
ensureNamespace('Nl.Uva.Sne.Drip.Commons.V1.Types');
exports.Nl.Uva.Sne.Drip.Commons.V1.Types.DeployParameter = class {

    /**
     * Constructs a DeployParameter from a JSON object
     *
     * @param Object o JSON object.
     */
    constructor(o) {
        var self = this;
        if (typeof o['cloudCertificateName'] !== 'undefined') {
            this.cloudCertificateName = o['cloudCertificateName'];
        }
        if (typeof o['IP'] !== 'undefined') {
            this.IP = o['IP'];
        }
        if (typeof o['user'] !== 'undefined') {
            this.user = o['user'];
        }
        if (typeof o['role'] !== 'undefined') {
            this.role = o['role'];
        }
    }

    /**
     * the cloudCertificateName
     *
     * @return string
     */
    getCloudCertificateName() {
        return this.cloudCertificateName;
    }

    /**
     * the cloudCertificateName
     *
     * @param string cloudCertificateName
     */
    setCloudCertificateName(cloudCertificateName) {
        this.cloudCertificateName = cloudCertificateName;
    }
    /**
     * the IP
     *
     * @return string
     */
    getIP() {
        return this.IP;
    }

    /**
     * the IP
     *
     * @param string IP
     */
    setIP(IP) {
        this.IP = IP;
    }
    /**
     * the user
     *
     * @return string
     */
    getUser() {
        return this.user;
    }

    /**
     * the user
     *
     * @param string user
     */
    setUser(user) {
        this.user = user;
    }
    /**
     * the role
     *
     * @return string
     */
    getRole() {
        return this.role;
    }

    /**
     * the role
     *
     * @param string role
     */
    setRole(role) {
        this.role = role;
    }

    /**
     * Returns a JSON object for this DeployParameter
     *
     * @return object
     */
    toJSON() {
        var json = {};
        var self = this;
        if (typeof this.cloudCertificateName !== 'undefined') {
            json['cloudCertificateName'] = this.cloudCertificateName;
        }
        if (typeof this.IP !== 'undefined') {
            json['IP'] = this.IP;
        }
        if (typeof this.user !== 'undefined') {
            json['user'] = this.user;
        }
        if (typeof this.role !== 'undefined') {
            json['role'] = this.role;
        }
        return json;
    }

}

/**
 * (no documentation provided)
 */
ensureNamespace('Nl.Uva.Sne.Drip.Commons.V1.Types');
exports.Nl.Uva.Sne.Drip.Commons.V1.Types.ClusterCredentials = class extends exports.Nl.Uva.Sne.Drip.Commons.V1.Types.OwnedObject {

    /**
     * Constructs a ClusterCredentials from a JSON object
     *
     * @param Object o JSON object.
     */
    constructor(o) {
        super(o);
        var self = this;
        if (typeof o['id'] !== 'undefined') {
            this.id = o['id'];
        }
        if (typeof o['key'] !== 'undefined') {
            this.key = o['key'];
        }
    }

    /**
     * (no documentation provided)
     *
     * @return string
     */
    getId() {
        return this.id;
    }

    /**
     * (no documentation provided)
     *
     * @param string id
     */
    setId(id) {
        this.id = id;
    }
    /**
     * the key
     *
     * @return string
     */
    getKey() {
        return this.key;
    }

    /**
     * the key
     *
     * @param string key
     */
    setKey(key) {
        this.key = key;
    }

    /**
     * Returns a JSON object for this ClusterCredentials
     *
     * @return object
     */
    toJSON() {
        var json = super.toJSON();
        var self = this;
        if (typeof this.id !== 'undefined') {
            json['id'] = this.id;
        }
        if (typeof this.key !== 'undefined') {
            json['key'] = this.key;
        }
        return json;
    }

}

/**
 * (no documentation provided)
 */
ensureNamespace('Nl.Uva.Sne.Drip.Commons.V1.Types');
exports.Nl.Uva.Sne.Drip.Commons.V1.Types.KeyValueHolder = class extends exports.Nl.Uva.Sne.Drip.Commons.V1.Types.OwnedObject {

    /**
     * Constructs a KeyValueHolder from a JSON object
     *
     * @param Object o JSON object.
     */
    constructor(o) {
        super(o);
        var self = this;
        if (typeof o['keyValue'] !== 'undefined') {
            this.keyValue = o['keyValue'];
        }
        if (typeof o['id'] !== 'undefined') {
            this.id = o['id'];
        }
    }

    /**
     * the keyValue
     *
     * @return array
     */
    getKeyValue() {
        return this.keyValue;
    }

    /**
     * the keyValue
     *
     * @param array keyValue
     */
    setKeyValue(keyValue) {
        this.keyValue = keyValue;
    }
    /**
     * the id
     *
     * @return string
     */
    getId() {
        return this.id;
    }

    /**
     * the id
     *
     * @param string id
     */
    setId(id) {
        this.id = id;
    }

    /**
     * Returns a JSON object for this KeyValueHolder
     *
     * @return object
     */
    toJSON() {
        var json = super.toJSON();
        var self = this;
        if (typeof this.keyValue !== 'undefined') {
            json['keyValue'] = this.keyValue;
        }
        if (typeof this.id !== 'undefined') {
            json['id'] = this.id;
        }
        return json;
    }

}

/**
 * (no documentation provided)
 */
ensureNamespace('Nl.Uva.Sne.Drip.Commons.V1.Types');
exports.Nl.Uva.Sne.Drip.Commons.V1.Types.CloudCredentials = class extends exports.Nl.Uva.Sne.Drip.Commons.V1.Types.OwnedObject {

    /**
     * Constructs a CloudCredentials from a JSON object
     *
     * @param Object o JSON object.
     */
    constructor(o) {
        super(o);
        var self = this;
        if (typeof o['id'] !== 'undefined') {
            this.id = o['id'];
        }
        if (typeof o['key'] !== 'undefined') {
            this.key = o['key'];
        }
        if (typeof o['keyIdAlias'] !== 'undefined') {
            this.keyIdAlias = o['keyIdAlias'];
        }
        this.loginKeys = [];
        if (o['loginKeys']) {
            o['loginKeys'].forEach(function(x, i){
                self.loginKeys[i] = new exports.Nl.Uva.Sne.Drip.Commons.V1.Types.LoginKey(x);
            });
        }
        if (typeof o['cloudProviderName'] !== 'undefined') {
            this.cloudProviderName = o['cloudProviderName'];
        }
        if (typeof o['keypass'] !== 'undefined') {
            this.keypass = o['keypass'];
        }
    }

    /**
     * (no documentation provided)
     *
     * @return string
     */
    getId() {
        return this.id;
    }

    /**
     * (no documentation provided)
     *
     * @param string id
     */
    setId(id) {
        this.id = id;
    }
    /**
     * the key
     *
     * @return string
     */
    getKey() {
        return this.key;
    }

    /**
     * the key
     *
     * @param string key
     */
    setKey(key) {
        this.key = key;
    }
    /**
     * the keyIdAlias
     *
     * @return string
     */
    getKeyIdAlias() {
        return this.keyIdAlias;
    }

    /**
     * the keyIdAlias
     *
     * @param string keyIdAlias
     */
    setKeyIdAlias(keyIdAlias) {
        this.keyIdAlias = keyIdAlias;
    }
    /**
     * the loginKeys
     *
     * @return Nl.Uva.Sne.Drip.Commons.V1.Types.LoginKey[]
     */
    getLoginKeys() {
        return this.loginKeys;
    }

    /**
     * the loginKeys
     *
     * @param Nl.Uva.Sne.Drip.Commons.V1.Types.LoginKey[] loginKeys
     */
    setLoginKeys(loginKeys) {
        this.loginKeys = loginKeys;
    }
    /**
     * the cloudProviderName
     *
     * @return string
     */
    getCloudProviderName() {
        return this.cloudProviderName;
    }

    /**
     * the cloudProviderName
     *
     * @param string cloudProviderName
     */
    setCloudProviderName(cloudProviderName) {
        this.cloudProviderName = cloudProviderName;
    }
    /**
     * the keypass
     *
     * @return string
     */
    getKeypass() {
        return this.keypass;
    }

    /**
     * the keypass
     *
     * @param string keypass
     */
    setKeypass(keypass) {
        this.keypass = keypass;
    }

    /**
     * Returns a JSON object for this CloudCredentials
     *
     * @return object
     */
    toJSON() {
        var json = super.toJSON();
        var self = this;
        if (typeof this.id !== 'undefined') {
            json['id'] = this.id;
        }
        if (typeof this.key !== 'undefined') {
            json['key'] = this.key;
        }
        if (typeof this.keyIdAlias !== 'undefined') {
            json['keyIdAlias'] = this.keyIdAlias;
        }
        if (this.loginKeys) {
            json['loginKeys'] = [];
            this.loginKeys.forEach(function(x, i){
                json['loginKeys'][i] = x.toJSON();
            });
        }
        if (typeof this.cloudProviderName !== 'undefined') {
            json['cloudProviderName'] = this.cloudProviderName;
        }
        if (typeof this.keypass !== 'undefined') {
            json['keypass'] = this.keypass;
        }
        return json;
    }

}

/**
 * (no documentation provided)
 */
ensureNamespace('Nl.Uva.Sne.Drip.Commons.V1.Types');
exports.Nl.Uva.Sne.Drip.Commons.V1.Types.Type = {

    /**
     * 
     */
    PRIVATE: "PRIVATE", 

    /**
     * 
     */
    PUBLIC: "PUBLIC"
};

/**
 * (no documentation provided)
 */
ensureNamespace('Nl.Uva.Sne.Drip.Commons.V1.Types');
exports.Nl.Uva.Sne.Drip.Commons.V1.Types.Script = class extends exports.Nl.Uva.Sne.Drip.Commons.V1.Types.OwnedObject {

    /**
     * Constructs a Script from a JSON object
     *
     * @param Object o JSON object.
     */
    constructor(o) {
        super(o);
        var self = this;
        if (typeof o['id'] !== 'undefined') {
            this.id = o['id'];
        }
        if (typeof o['name'] !== 'undefined') {
            this.name = o['name'];
        }
        if (typeof o['contents'] !== 'undefined') {
            this.contents = o['contents'];
        }
    }

    /**
     * the id
     *
     * @return string
     */
    getId() {
        return this.id;
    }

    /**
     * the id
     *
     * @param string id
     */
    setId(id) {
        this.id = id;
    }
    /**
     * the name
     *
     * @return string
     */
    getName() {
        return this.name;
    }

    /**
     * the name
     *
     * @param string name
     */
    setName(name) {
        this.name = name;
    }
    /**
     * the contents
     *
     * @return string
     */
    getContents() {
        return this.contents;
    }

    /**
     * the contents
     *
     * @param string contents
     */
    setContents(contents) {
        this.contents = contents;
    }

    /**
     * Returns a JSON object for this Script
     *
     * @return object
     */
    toJSON() {
        var json = super.toJSON();
        var self = this;
        if (typeof this.id !== 'undefined') {
            json['id'] = this.id;
        }
        if (typeof this.name !== 'undefined') {
            json['name'] = this.name;
        }
        if (typeof this.contents !== 'undefined') {
            json['contents'] = this.contents;
        }
        return json;
    }

}

/**
 * (no documentation provided)
 */
ensureNamespace('Nl.Uva.Sne.Drip.Commons.V1.Types');
exports.Nl.Uva.Sne.Drip.Commons.V1.Types.LoginKey = class extends exports.Nl.Uva.Sne.Drip.Commons.V1.Types.OwnedObject {

    /**
     * Constructs a LoginKey from a JSON object
     *
     * @param Object o JSON object.
     */
    constructor(o) {
        super(o);
        var self = this;
        if (typeof o['name'] !== 'undefined') {
            this.name = o['name'];
        }
        if (typeof o['id'] !== 'undefined') {
            this.id = o['id'];
        }
        if (typeof o['type'] !== 'undefined') {
            this.type = o['type'];
        }
        if (typeof o['attributes'] !== 'undefined') {
            this.attributes = o['attributes'];
        }
        if (typeof o['key'] !== 'undefined') {
            this.key = o['key'];
        }
    }

    /**
     * 
     *
     * @return string
     */
    getName() {
        return this.name;
    }

    /**
     * 
     *
     * @param string name
     */
    setName(name) {
        this.name = name;
    }
    /**
     * the id
     *
     * @return string
     */
    getId() {
        return this.id;
    }

    /**
     * the id
     *
     * @param string id
     */
    setId(id) {
        this.id = id;
    }
    /**
     * the type
     *
     * @return string
     */
    getType() {
        return this.type;
    }

    /**
     * the type
     *
     * @param string type
     */
    setType(type) {
        this.type = type;
    }
    /**
     * the attributes
     *
     * @return array
     */
    getAttributes() {
        return this.attributes;
    }

    /**
     * the attributes
     *
     * @param array attributes
     */
    setAttributes(attributes) {
        this.attributes = attributes;
    }
    /**
     * the key
     *
     * @return string
     */
    getKey() {
        return this.key;
    }

    /**
     * the key
     *
     * @param string key
     */
    setKey(key) {
        this.key = key;
    }

    /**
     * Returns a JSON object for this LoginKey
     *
     * @return object
     */
    toJSON() {
        var json = super.toJSON();
        var self = this;
        if (typeof this.name !== 'undefined') {
            json['name'] = this.name;
        }
        if (typeof this.id !== 'undefined') {
            json['id'] = this.id;
        }
        if (typeof this.type !== 'undefined') {
            json['type'] = this.type;
        }
        if (typeof this.attributes !== 'undefined') {
            json['attributes'] = this.attributes;
        }
        if (typeof this.key !== 'undefined') {
            json['key'] = this.key;
        }
        return json;
    }

}

/**
 * (no documentation provided)
 */
ensureNamespace('Nl.Uva.Sne.Drip.Commons.V1.Types');
exports.Nl.Uva.Sne.Drip.Commons.V1.Types.ToscaRepresentation = class extends exports.Nl.Uva.Sne.Drip.Commons.V1.Types.KeyValueHolder {

    /**
     * Constructs a ToscaRepresentation from a JSON object
     *
     * @param Object o JSON object.
     */
    constructor(o) {
        super(o);
        var self = this;
        if (typeof o['name'] !== 'undefined') {
            this.name = o['name'];
        }
    }

    /**
     * the name
     *
     * @return string
     */
    getName() {
        return this.name;
    }

    /**
     * the name
     *
     * @param string name
     */
    setName(name) {
        this.name = name;
    }

    /**
     * Returns a JSON object for this ToscaRepresentation
     *
     * @return object
     */
    toJSON() {
        var json = super.toJSON();
        var self = this;
        if (typeof this.name !== 'undefined') {
            json['name'] = this.name;
        }
        return json;
    }

}

/**
 * (no documentation provided)
 */
ensureNamespace('Nl.Uva.Sne.Drip.Commons.V1.Types');
exports.Nl.Uva.Sne.Drip.Commons.V1.Types.ProvisionInfo = class extends exports.Nl.Uva.Sne.Drip.Commons.V1.Types.KeyValueHolder {

    /**
     * Constructs a ProvisionInfo from a JSON object
     *
     * @param Object o JSON object.
     */
    constructor(o) {
        super(o);
        var self = this;
        if (typeof o['cloudcloudCredentialsID'] !== 'undefined') {
            this.cloudcloudCredentialsID = o['cloudcloudCredentialsID'];
        }
        if (typeof o['planID'] !== 'undefined') {
            this.planID = o['planID'];
        }
        if (typeof o['scriptID'] !== 'undefined') {
            this.scriptID = o['scriptID'];
        }
        if (typeof o['userKeyID'] !== 'undefined') {
            this.userKeyID = o['userKeyID'];
        }
        this.deployParameters = [];
        if (o['deployParameters']) {
            o['deployParameters'].forEach(function(x, i){
                self.deployParameters[i] = new exports.Nl.Uva.Sne.Drip.Commons.V1.Types.DeployParameter(x);
            });
        }
    }

    /**
     * the cloudCredentialsID
     *
     * @return string
     */
    getCloudcloudCredentialsID() {
        return this.cloudcloudCredentialsID;
    }

    /**
     * the cloudCredentialsID
     *
     * @param string cloudcloudCredentialsID
     */
    setCloudcloudCredentialsID(cloudcloudCredentialsID) {
        this.cloudcloudCredentialsID = cloudcloudCredentialsID;
    }
    /**
     * the planID
     *
     * @return string
     */
    getPlanID() {
        return this.planID;
    }

    /**
     * the planID
     *
     * @param string planID
     */
    setPlanID(planID) {
        this.planID = planID;
    }
    /**
     * the scriptID
     *
     * @return string
     */
    getScriptID() {
        return this.scriptID;
    }

    /**
     * the scriptID
     *
     * @param string scriptID
     */
    setScriptID(scriptID) {
        this.scriptID = scriptID;
    }
    /**
     * the userKeyID
     *
     * @return string
     */
    getUserKeyID() {
        return this.userKeyID;
    }

    /**
     * the userKeyID
     *
     * @param string userKeyID
     */
    setUserKeyID(userKeyID) {
        this.userKeyID = userKeyID;
    }
    /**
     * (no documentation provided)
     *
     * @return Nl.Uva.Sne.Drip.Commons.V1.Types.DeployParameter[]
     */
    getDeployParameters() {
        return this.deployParameters;
    }

    /**
     * (no documentation provided)
     *
     * @param Nl.Uva.Sne.Drip.Commons.V1.Types.DeployParameter[] deployParameters
     */
    setDeployParameters(deployParameters) {
        this.deployParameters = deployParameters;
    }

    /**
     * Returns a JSON object for this ProvisionInfo
     *
     * @return object
     */
    toJSON() {
        var json = super.toJSON();
        var self = this;
        if (typeof this.cloudcloudCredentialsID !== 'undefined') {
            json['cloudcloudCredentialsID'] = this.cloudcloudCredentialsID;
        }
        if (typeof this.planID !== 'undefined') {
            json['planID'] = this.planID;
        }
        if (typeof this.scriptID !== 'undefined') {
            json['scriptID'] = this.scriptID;
        }
        if (typeof this.userKeyID !== 'undefined') {
            json['userKeyID'] = this.userKeyID;
        }
        if (this.deployParameters) {
            json['deployParameters'] = [];
            this.deployParameters.forEach(function(x, i){
                json['deployParameters'][i] = x.toJSON();
            });
        }
        return json;
    }

}

/**
 * (no documentation provided)
 */
ensureNamespace('Nl.Uva.Sne.Drip.Commons.V1.Types');
exports.Nl.Uva.Sne.Drip.Commons.V1.Types.Plan = class extends exports.Nl.Uva.Sne.Drip.Commons.V1.Types.KeyValueHolder {

    /**
     * Constructs a Plan from a JSON object
     *
     * @param Object o JSON object.
     */
    constructor(o) {
        super(o);
        var self = this;
        if (typeof o['name'] !== 'undefined') {
            this.name = o['name'];
        }
        if (typeof o['toscaID'] !== 'undefined') {
            this.toscaID = o['toscaID'];
        }
        if (typeof o['level'] !== 'undefined') {
            this.level = o['level'];
        }
        this.loweLevelPlanIDs = [];
        if (o['loweLevelPlanIDs']) {
            o['loweLevelPlanIDs'].forEach(function(x, i){
                self.loweLevelPlanIDs[i] = x;
            });
        }
    }

    /**
     * the name
     *
     * @return string
     */
    getName() {
        return this.name;
    }

    /**
     * the name
     *
     * @param string name
     */
    setName(name) {
        this.name = name;
    }
    /**
     * the toscaID
     *
     * @return string
     */
    getToscaID() {
        return this.toscaID;
    }

    /**
     * the toscaID
     *
     * @param string toscaID
     */
    setToscaID(toscaID) {
        this.toscaID = toscaID;
    }
    /**
     * the level
     *
     * @return integer
     */
    getLevel() {
        return this.level;
    }

    /**
     * the level
     *
     * @param integer level
     */
    setLevel(level) {
        this.level = level;
    }
    /**
     * the loweLevelPlansIDs
     *
     * @return string[]
     */
    getLoweLevelPlanIDs() {
        return this.loweLevelPlanIDs;
    }

    /**
     * the loweLevelPlansIDs
     *
     * @param string[] loweLevelPlanIDs
     */
    setLoweLevelPlanIDs(loweLevelPlanIDs) {
        this.loweLevelPlanIDs = loweLevelPlanIDs;
    }

    /**
     * Returns a JSON object for this Plan
     *
     * @return object
     */
    toJSON() {
        var json = super.toJSON();
        var self = this;
        if (typeof this.name !== 'undefined') {
            json['name'] = this.name;
        }
        if (typeof this.toscaID !== 'undefined') {
            json['toscaID'] = this.toscaID;
        }
        if (typeof this.level !== 'undefined') {
            json['level'] = this.level;
        }
        if (this.loweLevelPlanIDs) {
            json['loweLevelPlanIDs'] = [];
            this.loweLevelPlanIDs.forEach(function(x, i){
                json['loweLevelPlanIDs'][i] = x;
            });
        }
        return json;
    }

}
  
  /**
   * Ensures that a namespace exists.
   */
  function ensureNamespace(namespace){
    var current = exports;
    namespace.split('.').forEach(function(name){
      if(typeof current[name] === 'undefined'){
        current[name] = {};
      }
      current = current[name];
    });
  }

}));

